﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
  using System;

  using HeuristicLab.Algorithms.PushGP.Stack;

  public abstract class PushResultExpression<T> : StatelessExpression {
    protected PushResultExpression(string stringRepresentation) : base(stringRepresentation) { }

    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc) {
      if (stack.Count < count) return;

      stack.PushResult(count, templateFunc);
    }

    protected void Eval(IStack<T> stack, int count, Func<T[], T> templateFunc, T ignoreValue) {
      if ((stack.Count < count) || stack.Top.Equals(ignoreValue)) return;

      stack.PushResult(count, templateFunc);
    }

    protected void Eval<R>(IStack<T> stack, IStack<R> resultStack, int count, Func<T[], R> templateFunc) {
      if (stack.Count < count) return;

      var items = stack.Pop(count);
      var result = templateFunc(items);

      resultStack.Push(result);
    }
  }
}