﻿namespace HeuristicLab.BenchmarkSuite.Problems {
  using HeuristicLab.BenchmarkSuite.ProblemData;

  public class NegativeToZero : BenchmarkSuiteDataDescriptor<long[], long[]> {
    private const string displayMame = "Negative To Zero";
    private const string description = "Given a vector of integers, return the vector where all negative integers have been replaced by 0.";

    public override string Name { get { return displayMame; } }
    public override string Description { get { return description; } }

    protected override int InputCount { get { return 1; } }
    protected override int OutputCount { get { return 1; } }

    public override long[] ConvertInput(string[] input) {
      return ConvertIntegers(input[0]);
    }

    public override long[] ConvertOutput(string[] output) {
      return ConvertIntegers(output[0]);
    }

    public override IPushData CreatePushData(Example<long[], long[]>[] training, Example<long[], long[]>[] test) {
      return new NegativeToZeroPushData(training, test);
    }
  }
}
